--#####################################--
--###  Initalizations  				###--
--#####################################--

dofile("settings.ini")

ERR_COULD_NOT_CONNECT = [[Could not connect to %s
Please check:
-That the wlan switch is in the on position
-That %s is properly configured.]]

ERR_NO_CONNECTIONS_FOUND = [[No network connections found.
Quit the program and create a connection.
Note. If you have one or more connections configured,
and still can see this message, the only solution
is to delete and recreate the connections. This
seems to be a bug with LUA's network
enumeration.]]

ERR_TIMEOUT_CONNECTING = [[Timeout connecting to %s, port %s
Please check:
-The address and port number of the PC.
-That foo_controlserver is enabled.
-That Foobar2k is running.]]

ERR_SERVER_FULL = [[Server is full
Either:
-Increase the number of clients that are able to connect.
-Disconnect unesscessary clients.
Toggle the wlan switch to reconnect.]]

CONNECTION_TIMEOUT = 5000

Fontblit = {
			hSize = 7,
			lSpace = 1,
			vPos = {1, 16, 30},
			vSize = {12, 13, 12} }

titlebar = {
			scroll = 0,
			scrollWait = 0,
			scrollImage = Image.createEmpty(401, 14) }

networkConnections = {
						count = 0,
						lines = 4,
						active = 0,
						topItem = 0,
						items = { } }

playlistorder = {
				count = 6,
				lines = 6,
				active = 0,
				topItem = 0 }

playlist = {
			count = 1,
			lines = 8,
			active = 0,
			topItem = 0,
         	scroll = 0,
			scrollNum = 126,
			scrollImage = Image.createEmpty(512, 14),
			tmpImg = { },
			status = { },
			number = {0},
			name = {"Queue"} }
			
tracklist = {
			lines = 14,
			active = 0,
			topItem = 0,
         	scroll = 0,
			scrollNum = 315,
			scrollImage = Image.createEmpty(512, 14),
			tmpImg = { },
			status = { },
			index={ },
			length={ },
			artist={ },
			album={ },
			tracknumber={ },
			title={ } }

background = {
			queueActive = 0 }
				
currentlyPlaying = {
				timer = Timer.new() }
						
serverinfo = {
			volume = 0}

repeatDelay = Timer.new()

background.image = Image.load("Images\\main.png")
background.dialog = Image.load("Images\\dialog.png")
background.scroller = Image.load("Images\\scroller.png")
background.order= Image.load("Images\\order.png")
background.focus = Image.load("Images\\focus.png")
background.buttons = Image.load("Images\\buttons.png")

Wlan.term()
Wlan.init()
configs = Wlan.getConnectionConfigs()

for key, value in ipairs(configs) do
	networkConnections.items[key] = {name = value, idx = key }
	networkConnections.count = key
end

if networkConnections.count == 0 then
	errorMsg = ERR_NO_CONNECTIONS_FOUND
else
	background.activeControl = networkConnections
end

--#####################################--
--### Font Blit 					###--
--### Peter Thoman aka Durante		###--
--#####################################--

function Fontblit:new(file, tab)

	f = tab or {}
	setmetatable(f, self)
	self.__index = self
	f.image = Image.load(file)
	return f
	
end

function Fontblit:print(d,text, x, y)
	local ox = x
	local d, hm, hs, vp1, vp2, vp3, vs1, vs2, vs3 =
		d, self.hSize, self.hSize,
		self.vPos[1], self.vPos[2], self.vPos[3],
		self.vSize[1], self.vSize[2], self.vSize[3]
	local istart, iend, istep, b = 1, string.len(text), 1, 0

	for i=istart, iend, istep do
	
		b = string.byte(text, i)
		if b >= 97 then
			b = b - 97
			d:blit(x, y+1, self.image, b*hs, vp2, hs, vs2)
		elseif b >= 65 then
			b = b - 65
			d:blit(x, y, self.image, b*hs, vp1, hs, vs1)
		elseif b >= 33 then
			b = b - 33
			d:blit(x, y, self.image, b*hs, vp3, hs, vs3)
		elseif b == 10 then -- newline
			y = y + vs1 + self.lSpace
			x = ox
		end
		x = x + hm
		
	end
	
end

--#####################################--
--### TmpImaging					###--
--#####################################--

function createTmpImages(table,x,y)
	local p
	
	for i = 1, table.lines do
	
  		p = {img, idx}
		p.img = Image.createEmpty(x, y)
		table.tmpImg[i] = p
		
	end
	
end

function freeTmpImages(table)

	for i = 1, table.lines do
	
		table.tmpImg[i].idx = nil
		
	end
	
	table.idx = nil

end

function getTmpImage(table,idx)

  	free = nil
  	match = nil
  	
 	for i = 1, table.lines do
 	
   		if (not free) and ((not table.tmpImg[i].idx) or (table.tmpImg[i].idx < table.topItem+1) or (table.tmpImg[i].idx > table.topItem+table.lines)) then
     		free = i
   		elseif table.tmpImg[i].idx == idx then
     		match = i
   		end
   	
  	end
  	
	return match, free
		
end

function drawItem(table,item, x, y, image)
	local color, colors
	
	if image ~= screen then
		VeraMonoFontWhite:print(image,item, x+3, y+1)
	else
		if table.idx ~= table.active then
			table.idx= table.active
			table.scroll = 0
			table.scrollImage:clear(Color.new(129,133,132))
			VeraMonoFontWhite:print(table.scrollImage,item,0,0)
			i = 0
			table.scrollLength = table.scrollNum
			
			for x = table.scrollNum, 511 do
			
				color = table.scrollImage:pixel(x, 9)
				colors = color:colors()
				
				if colors.r > 130 then
					i = 0
				else
					i = i + 1
					if i > 20 then
						table.scrollLength = x - 20
						break
					end
				end
			end
			
		end
		
		l = table.scrollNum
		
		if table.scrollLength-table.scroll < table.scrollNum then
			l = table.scrollLength-table.scroll
			
			if l == -20 then
				table.scroll = 0
			end
		end
		
		image:blit(x+3,y+3,table.scrollImage, table.scroll, 0, l, 14, true)
		
		if l < table.scrollNum-20 then
			image:blit(x+3+l+20,y+3,table.scrollImage, 0, 0, table.scrollNum-l-20, 14, true)
		end
		
		if table.scrollLength > table.scrollNum then
			table.scroll = table.scroll +1
		end
		
	end
	
end

--#####################################--
--### Essentials					###--
--#####################################--

function moveActive(list, step)

	if list.count ~= nil then
		list.active = math.mod(list.active+list.count+step,list.count)
		
		if (list.active > list.topItem+(list.lines-1)) or (list.active < list.topItem) then
			list.topItem = math.mod(list.topItem+list.count-(list.lines-1)+step, list.count-(list.lines-1))
		end
		
	end
	
end

function connectToWlan()
	local timeout

	for i = 1, 3 do
	
		if Wlan.useConnectionConfig(networkConnections.items[networkConnections.active+1].idx + 1) then
			ipAddress = Wlan.getIPAddress()
			
			if ipAddress then
				socket = Socket.connect(IP_ADDRESS,SERVER_PORT)
				timeout = 0
				
				while not socket:isConnected() do
				
					System.sleep(1)
					timeout = timeout + 1
					
					if timeout >= CONNECTION_TIMEOUT then
					
						errorMsg = string.format(ERR_TIMEOUT_CONNECTING,IP_ADDRESS,SERVER_PORT)
						socket:close()
						return nil
					end
					
				end
				
				return true
			end
			
		end
		
	end
	
	errorMsg = string.format(ERR_COULD_NOT_CONNECT, networkConnections.items[networkConnections.active+1].name, networkConnections.items[networkConnections.active+1].name)
	return false
	
end

function setvolume(y)
	local newvolume
	
	if y <= -120 and serverinfo.volume < 0 then
		newvolume = serverinfo.volume + 10
	elseif y <= -80 and y > 120 and serverinfo.volume < 0 then
		newvolume = serverinfo.volume + 5
	elseif y <= -30 and y > -80 and serverinfo.volume < 0 then
		newvolume = serverinfo.volume + 3
	elseif y >=30 and y < 80 and serverinfo.volume > -100.00 then
		newvolume = serverinfo.volume - 3
	elseif y >= 80 and y < 120 and serverinfo.volume > -100.00 then
		newvolume = serverinfo.volume - 5
	elseif y >= 120 and serverinfo.volume > -100.00 then
		newvolume = serverinfo.volume - 10
	end
	
	if newvolume then
		socket:send("vol " .. newvolume .. "\r\n")
	end
	
end

function seek(x)
   local newseek
   
	if (currentlyPlaying.status == "111") or (currentlyPlaying.status == "113") then
		if x <= -120 then
			newseek = - 10
		elseif x <= -80 and x > 120 then
			newseek = - 5
		elseif x <= -30 and x > -80 then
			newseek = - 3
		elseif x >=30 and x < 80 then
			newseek = 3
		elseif x >= 80 and x < 120 then
			newseek = 5
		elseif x >= 120 then
			newseek = 10
		end
		
		if newseek then
			socket:send("seek delta " .. newseek .. "\r\n")
		end
		
	end
	
end

--#####################################--
--### Incoming Communications		###--
--#####################################--

function eventwatcher()

		local incoming, error ,buffer , data, line, listnum, s, e
		local function split(str, pat)
			local t = {}
		 	local fpat = "(.-)"..pat
		 	local last_end = 1
		 	local s,e,cap = string.find(str, fpat, 1)
		 	while s do
		 		 if s~=1 or cap~="" then
				 	 table.insert(t,cap)
  				 end
				 last_end = e+1
  				 s,e,cap = string.find(str, fpat, last_end)
		 	end
		 	if last_end<=string.len(str) then
 		 	 	cap = string.sub(str,last_end)
   		 	table.insert(t,cap)
		 	end
			return t
		end

	   	ipAddress = Wlan.getIPAddress()
	   	if not ipAddress then
	    	background.activeControl = networkConnections
		else
      
		incoming, error = socket:recv()
		
		if incoming then
			buffer = ""
			while true do
				buffer = buffer .. incoming
				if string.len(incoming) == 0 then
					break
				end
				System.sleep(pauserate)
				incoming, error = socket:recv()
			end
			
         	data = split(buffer,'|\r\n')
         	
 			for key, lines in ipairs(data) do
 			
            	line = split(lines,"|")
             
             	if (line[1] == "999") and (line[2] == "The server is full. Try again later.") then
               		errorMsg = ERR_SERVER_FULL
             
             	elseif (line[1] == "111") or (line[1] == "113") or (line[1] == "112") then
				 	 currentlyPlaying.status = line[1]
				 	 currentlyPlaying.string = "[" ..  line[2] .. "]" .. " | " .. "(" ..  line[8] .. ")" .. " | " .. line[9] .. " | " .. line[6] .. " | " .. line[7] .. " | "
				 	 if (line[5] ~= "?") then
				 	 	currentlyPlaying.totaltime = tonumber(line[5]*1000)
				 	 	currentlyPlaying.timer:reset(tonumber(line[4])*1000)
				 	 	
				 	 	if (currentlyPlaying.status == "111") then
				 	 	 	 currentlyPlaying.timer:start()
				 		else
				 			 currentlyPlaying.timer:stop()
				 		end
				 		
				 	else
				 		 currentlyPlaying.totaltime = 0
				 		 currentlyPlaying.timer:reset()
				 	end

				elseif (line[1] == "222") then
				    serverinfo.volume = tonumber(line[2])

				elseif (line[1] == "333") then
					serverinfo.order = line[2]
					
				elseif (line[1] == "400") then
					playlist.count = tonumber(line[2])+1
				
				elseif (line[1] == "401") or (line[1] == "402") then
					listnum = tonumber(line[2])+2
					playlist.name[listnum] = line[3]
					playlist.number[listnum] = line[4]	
					playlist.active = 0
               		playlist.topItem = 0
					
				elseif (line[1] == "600") then
					tracklist.count = tonumber(line[3])
					
				elseif (line[1] == "601") or (line[1] == "602") or (line[1] == "603") or (line[1] == "604") then
					listnum = tonumber(line[3])
					tracklist.index[listnum] = line[2]
					tracklist.length[listnum] = line[4]
					tracklist.artist[listnum] = line[5]
					tracklist.album[listnum] = line[6]
					tracklist.tracknumber[listnum] = line[7]
					tracklist.title[listnum] = line[8]
					freeTmpImages(tracklist)
					tracklist.active = 0
					tracklist.topItem = 0
				
				elseif (line[1] == "800") then
					playlist.number[1] = tonumber(line[2])
					if (background.queueActive == 1) then
						tracklist.count = tonumber(line[2])
					end
					freeTmpImages(playlist)
					
				elseif (line[1] == "801") and (background.queueActive == 1) then
					listnum = tonumber(line[2])
					tracklist.index[listnum] = line[3]
					tracklist.length[listnum] = line[5]
					tracklist.artist[listnum] = line[6]
					tracklist.album[listnum] = line[7]
					tracklist.tracknumber[listnum] = line[8]
					tracklist.title[listnum] = line[9]
               		freeTmpImages(tracklist)
               		tracklist.active = 0
               		tracklist.topItem = 0
               
				end
				
			end
			
		end
	end
	
end

function getdataCO()

    System.sleep(pauserate)
	socket:send("vol\r\n")
	System.sleep(pauserate)
	coroutine.yield()
	System.sleep(pauserate)
	socket:send("order\r\n")
	System.sleep(pauserate)
    coroutine.yield()
    System.sleep(pauserate)
	socket:send('listinfo all\r\n')
	System.sleep(pauserate)
	coroutine.yield()
    System.sleep(pauserate)
	socket:send('list\r\n')
	System.sleep(pauserate)

end

function manageCO()

    if co and coroutine.status(co) ~= 'dead' then
    	coroutine.resume(co)
  	end
  	
end

--#####################################--
--###  Input Functions              ###--
--#####################################--

function inputControl()
	pad = Controls.read()
	
	if (pad ~= oldPad) or (repeatDelay:time() >= REPEAT_DELAY) then
		if errorMsg then
 			if pad:cross() then
				errorMsg = nil
			end
			
		elseif background.activeControl == networkConnections then
    	  	selectNetworkControl(pad)
    	elseif background.activeControl == order then
     	 	selectorderControl(pad)
    	else
    	
      	if background.activeControl == tracklist then
        		selecttracklistControl(pad)
      	elseif background.activeControl == playlist then
        		selectplaylistControl(pad)
      	end

       if pad:start() then
   				co = coroutine.create(getdataCO)
      	elseif pad:square() then
        		socket:send("stop\r\n")
      	elseif pad:triangle() then
        		socket:send("pause\r\n")
      	elseif pad:circle() then
        		socket:send("rand\r\n")
      	elseif pad:r() then
        		socket:send("next\r\n")
      	elseif pad:l() then
        		socket:send("prev\r\n")
      	else
      
       		setvolume(pad:analogY())
       		seek(pad:analogX())
       
      	end

    	end

    if pad == oldPad then
      repeatDelay:reset(REPEAT_DELAY-REPEAT_RATE)
    else
      repeatDelay:reset()
    end
    
    oldPad = pad
    
  end
  
  repeatDelay:start()
  
end


function selectNetworkControl(pad)

	if pad:up() then
		moveActive(networkConnections, -1)
	elseif pad:down() then
		moveActive(networkConnections, 1)
	elseif pad:cross() then
		if networkConnections.items[networkConnections.active+1].idx > 0 then
			if connectToWlan() then
			    co = coroutine.create(getdataCO)
				background.activeControl = playlist
			end
		end
	end
	
end

function selectorderControl(pad)

	if pad:up() then
		moveActive(playlistorder, -1)
	elseif pad:down() then
		moveActive(playlistorder, 1)
	elseif pad:right() then
		background.activeControl = playlist
	elseif pad:cross() then
	
		if playlistorder.active == 0 then
			socket:send("order default\r\n")
		elseif playlistorder.active == 1 then
			socket:send("order repeatplaylist\r\n")
		elseif playlistorder.active == 2 then
			socket:send("order repeattrack\r\n")
		elseif 	playlistorder.active == 3 then
			socket:send("order shufflealbum\r\n")
		elseif 	playlistorder.active == 4 then
			socket:send("order shuffledirectory\r\n")
		elseif 	playlistorder.active == 5 then
			socket:send("order shuffletrack\r\n")
		end
		
	end
	
end

function selectplaylistControl(pad)

	if pad:cross() then
	
		if playlist.active == 0 then
			socket:send("queue\r\n")
			background.queueActive = 1
		else
			socket:send("list " .. playlist.active-1 .. "\r\n")
			background.queueActive = 0
		end
		
	elseif pad:up() then
		moveActive(playlist, -1)
	elseif pad:down() then
		moveActive(playlist, 1)
	elseif pad:left() then
	    background.activeControl = order
	elseif pad:right() then
		background.activeControl = tracklist
	end
	
end

function selecttracklistControl(pad)

	if pad:cross() and background.queueActive == 0 and tracklist.count ~= 0 then
	    socket:send("play " .. tracklist.index[tracklist.active+1] .. " " .. tracklist.active+1 .. "\r\n")
	elseif pad:select() then
	
		if background.queueActive == 1 then
			socket:send("queue del " .. tracklist.active+1 .. "\r\n")
		else
			socket:send("queue " .. tracklist.index[tracklist.active+1] .. " " .. tracklist.active+1 .. "\r\n")
		end
		
	elseif pad:up() then
		moveActive(tracklist, -1)
	elseif pad:down() then
		moveActive(tracklist, 1)
	elseif pad:left() then
	    background.activeControl = playlist
	end
	
end

--#####################################--
--###  Drawing Functions            ###--
--#####################################--

function drawPlayElements()

	if (currentlyPlaying.status == "111") or (currentlyPlaying.status == "113") then
	   	if titlebar.scrollWait >= 30 then
   		
			titlebar.scroll = math.mod(titlebar.scroll+480+1,480)
   			restart = true
   			
   			for x = 0, 20 do
   		  	
   				color = titlebar.scrollImage:pixel(x, 6)
   				colors = color:colors()
   		    	
   				if colors.r > 100 then
   					restart = false
   		   			break
   	 			end
   	 	
    		end
    		
    		if restart then
   				titlebar.scrollWait = 0
			end
			
		else
   			titlebar.scrollWait = titlebar.scrollWait +1
   			titlebar.scroll = 0
		end
		
    	if (currentlyPlaying.status == "111") then
			VeraMonoFontWhite:print(screen,"Playing:",20,2)
			screen:blit(67,44,background.buttons,72,0,24,24,true)
	   	elseif (currentlyPlaying.status == "113") then
	   		VeraMonoFontWhite:print(screen,"Paused:",20,2)
	   		screen:blit(67,44,background.buttons,72,0,24,24,true)
    		screen:blit(23,44,background.buttons,24,0,24,24,true)
		end
		
		titlebar.scrollImage:clear(Color.new(73,78,88))
		VeraMonoFontWhite:print(titlebar.scrollImage,currentlyPlaying.string,-titlebar.scroll,0)
		screen:blit(76,2,titlebar.scrollImage, 0, 0, 401, 14, false)

    	if currentlyPlaying.totaltime == 0 then
			screen:blit(3,69,background.scroller,0,0,9,16,false)
		else

			if currentlyPlaying.timer:time() / currentlyPlaying.totaltime * 132 >= 133 then
				currentlyPlaying.timer:stop()
			else
				screen:blit(3+currentlyPlaying.timer:time() / currentlyPlaying.totaltime * 132,69,background.scroller,0,0,9,16,false)
			end

		end

 	else
 		screen:blit(1,43,background.buttons,0,0,24,24,true)
	    screen:blit(3,69,background.scroller,0,0,9,16,false)
	end

end

function drawVolume()

	VeraMonoFontBlack:print(screen,serverinfo.volume .. " dB",406,253)
	screen:blit(135-1.32*math.abs(serverinfo.volume),90,background.scroller,0,0,9,16,false)
	
end

function drawOrder()

	if serverinfo.order == "Default" then
	   screen:blit(5,25,background.order,0,2,124,13,false)
	elseif serverinfo.order == "Repeat (playlist)" then
	   screen:blit(5,25,background.order,0,18,124,13,false)
	elseif serverinfo.order == "Repeat (track)" then
	   screen:blit(5,25,background.order,0,34,124,13,false)
	elseif serverinfo.order == "Shuffle (albums)" then
	   screen:blit(5,25,background.order,0,50,124,13,false)
	elseif serverinfo.order == "Shuffle (directories)" then
	   screen:blit(5,25,background.order,0,66,124,13,false)
	elseif serverinfo.order == "Shuffle (tracks)" then
	   screen:blit(5,25,background.order,0,82,124,13,false)
	end

	if background.activeControl == order then
		screen:blit(3,40,background.order,0,0,139,96,false)
		
		for i = 0, playlistorder.lines-1 do
			if playlistorder.topItem+i < playlistorder.count then

				if (i == playlistorder.active-playlistorder.topItem) then
					screen:blit(3, 40+(16)*i, background.focus, 0, 0, 139, 16, true)
				end
				
			else
				break
			end
			
		end
		
	end
	
end

function drawPlaylist()

	for i = 0, playlist.lines-1 do
		
		if playlist.topItem+i < playlist.count then
			if (i == playlist.active-playlist.topItem) and (background.activeControl == playlist) then
				
				if background.activeControl == playlist then
					screen:blit(6, 118+16*i, background.focus, 0,0,132,16,true)
				end

				drawItem(playlist,playlist.name[playlist.topItem+i+1] .. " (" .. playlist.number[playlist.topItem+i+1] .. ")", 6, 116+16*i, screen)
			else
				match, free = getTmpImage(playlist,playlist.topItem+i+1)
					
				if not match  then
					match = free
					playlist.tmpImg[match].idx = playlist.topItem+i+1
					playlist.tmpImg[match].img:clear(Color.new(96,101,99))
					drawItem(playlist,playlist.name[playlist.topItem+i+1] .. " (" .. playlist.number[playlist.topItem+i+1] .. ")", 0, 0, playlist.tmpImg[match].img)
				end

				screen:blit(6,118+16*i, playlist.tmpImg[match].img, 0, 0, 130, 16, true)
			end
				
		else
			break
		end
			
	end

	VeraMonoFontBlack:print(screen, playlist.count .. " Object(s)  " .. math.floor(playlist.active/playlist.lines)+1 .. "/" .. math.floor(playlist.count/playlist.lines)+1,6,253)
	
end

function drawTracklist()

	local function millisecondsToTime(time)
  		hour = math.floor(time/3600)
  		min =  math.floor((time-(hour*3600))/60)
  		sec =  time-(hour*3600)-(min*60)
  
  		if hour > 0 then str = string.format("%.2d:",hour) else str = "" end
  		return str .. string.format("%.2d:",min) .. string.format("%.2d",sec) 
	end

	if tracklist.count and tracklist.count ~= 0 then

		for i = 0, tracklist.lines-1 do
		
			if tracklist.topItem+i < tracklist.count then
				if (i == tracklist.active-tracklist.topItem) and (background.activeControl == tracklist) then
					if background.activeControl == tracklist then
					
						screen:blit(151, 24+16*i, background.focus,0,0,321,16,true)
					end
					
					drawItem(tracklist,tracklist.tracknumber[tracklist.topItem+i+1] .. " - " .. tracklist.title[tracklist.topItem+i+1] .. " - " .. tracklist.album[tracklist.topItem+i+1] .. " - " .. tracklist.artist[tracklist.topItem+i+1], 151, 22+16*i, screen)
				else
					match, free = getTmpImage(tracklist,tracklist.topItem+i+1)
					
					if not match  then
						match = free
						tracklist.tmpImg[match].idx = tracklist.topItem+i+1
						tracklist.tmpImg[match].img:clear(Color.new(96,101,99))
						drawItem(tracklist,tracklist.tracknumber[tracklist.topItem+i+1] .. " - " .. tracklist.title[tracklist.topItem+i+1] .. " - " .. tracklist.album[tracklist.topItem+i+1] .. " - " .. tracklist.artist[tracklist.topItem+i+1], 0, 0, tracklist.tmpImg[match].img)
					end
					
					screen:blit(151,24+16*i, tracklist.tmpImg[match].img, 0, 0, 318, 16, true)
				end
				
			else
				break
			end
			
		end
		
		VeraMonoFontBlack:print(screen,tracklist.count .. " Object(s)  " .. math.floor(tracklist.active/tracklist.lines)+1 .. "/" .. math.floor(tracklist.count/tracklist.lines)+1,150,253)
	
		if tracklist.length[tracklist.active+1] == "?" then
			VeraMonoFontBlack:print(screen,"?",335,253)
		else
			VeraMonoFontBlack:print(screen,millisecondsToTime(tracklist.length[tracklist.active+1]),335,253)
		end
	
	end

end

function drawSelectNetwork()

	if background.activeControl == networkConnections then
		screen:blit(35, 55, background.dialog, 0, 0, 400, 175, false)
		VeraMonoFontWhite:print(screen,"Network Connections",41,60)
		
		for i = 0, networkConnections.lines-1 do
		
			if networkConnections.topItem+i < networkConnections.count then

				if (i == networkConnections.active-networkConnections.topItem) then
					screen:blit(45, 91+(16)*i, background.focus, 0, 0, 380, 16, true)
				end
				
				VeraMonoFontBlack:print(screen,networkConnections.items[networkConnections.topItem+i+1].name,49,92+(16)*i)
				
			else
				break
			end
			
		end
		
	end
	
end

function drawError()

	if errorMsg then
		screen:blit(35, 55, background.dialog, 0, 0, 400, 175, false)
		VeraMonoFontWhite:print(screen,"Error",41,60)
      	VeraMonoFontBlack:print(screen,errorMsg,43,89)
	end
	
end

VeraMonoFontWhite = Fontblit:new("Images\\Fonts\\VeraMonoWhite.png")
VeraMonoFontBlack = Fontblit:new("Images\\Fonts\\VeraMonoBlack.png")

createTmpImages(playlist,132, 16)
createTmpImages(tracklist,321, 16)

--#####################################--
--###  Main Loop			        ###--
--#####################################--

while true do

	inputControl()
	
	eventwatcher()
    manageCO()

	screen:blit(0,0,background.image,0,0,480,272,false)
	drawPlayElements()
	drawVolume()
	drawPlaylist()
	drawTracklist()
	drawOrder()
	drawSelectNetwork()
	drawError()
	
	screen.flip()
	
end